#For more control of this common code you can:
# - use a GitLab file lock to prevent changes
# - use a CODEOWNERS file to ensure specific users or groups review all changes
# - put this file in a completely different repo and reference it by an include
# - file could also be included by an https url
# If a seperate file is unnecessary these contents could be combine with .gitlab-ci.yml

# Starting with a dot causes the job to be skipped, but it can still be used by "extends:" as a template for another job
.grp-config-vars-contents:
  stage: display_config_vars
  
  only:
    refs:
      - merge_requests
      - sandbox
      - stage
      - production
  script:
    - |
      echo "***** SET VARIABLES TO USE LATER ****"
      echo "export DYNPASSVARS_SUPPORT=creates-vars-at-job-level-but-passed-as-artifacts" >> $MAVEN_PROJ_DIR/dynamicbuildvars.sh
      echo "MY_SECRET=dont-persist-as-a-file" >> deploy.env  #Limitations of dotenv: https://docs.gitlab.com/ee/ci/pipelines/job_artifacts.html#artifactsreportsdotenv
      echo "MY_OTHER_SECRET=$(LC_CTYPE=C tr -dc A-Za-z0-9_\!\@\#\$\%\^\&\*\(\)-+= < /dev/urandom | head -c 32 | xargs)" >> deploy.env #random number
      echo "***** GROUP INHERITED VARIABLES *****"
      echo "This maven project is: $MAVEN_PROJ_DIR"
      echo "Building for environment (branch): $CI_COMMIT_REF_NAME"
      echo "Building for repository (which may be a scope like a customer): $CI_PROJECT_NAME"      
      echo "The value of TOP_SCOPE_VAR1 is $TOP_SCOPE_VAR1"
      echo "The value of TOP_SCOPE_VAR2 is $TOP_SCOPE_VAR2"
      echo "The value of TOP_SCOPE_VAR3 is $TOP_SCOPE_VAR3"
      echo "The value of SUBSCOPE_VAR1 is $SUBSCOPE_VAR1"
      echo "The value of SUBSCOPE_VAR2 is $SUBSCOPE_VAR2"
      echo "The value of REPO_SCOPE_VAR1 is $REPO_SCOPE_VAR1"
      echo "If you never want your built config file nor the built java artifact to be"
      echo "captured to artifacts or the runner cache, you must create the config, do the build"
      echo "and upload the artifact to your CD mechanism all in one GitLab job." 
  environment:
    name: $CI_COMMIT_REF_NAME
  artifacts:
    paths: [ plugin1/dynamicbuildvars.sh ]
    reports:
      dotenv: deploy.env  #propagates variables into the pipeline level, but never stores the actual file

# Starting with a dot causes the job to be skipped, but it can still be used by "extends:" as a template for another job
.config-vars-environscoped-contents:
  stage: display_config_vars2
  
  only:
    refs:
      - merge_requests
      - sandbox
      - stage
      - production

  environment:
    name: $CI_COMMIT_REF_NAME
  script:
    - |
      echo "***** FILE and ENVIRONMENT SCOPED REPO VARIABLES *****"
      source "$MAVEN_PROJ_DIR/.buildvars.sh"
      echo "This maven project is: $MAVEN_PROJ_DIR"
      echo "Building for environment (branch): $CI_COMMIT_REF_NAME"
      echo "Building for repository (which may be a scope like a customer): $CI_PROJECT_NAME"
      echo "The value of a masked group variable was passed to PWD1, whose value is: $PWD1"
      echo "The value of NONSECRETSAMEFORALLENVIRONMENTSVAR1 from $MAVEN_PROJ_DIR/.buildvars.sh is: $NONSECRETSAMEFORALLENVIRONMENTSVAR1"
      echo "The value of VISIBLE_ENV_DATA is $VISIBLE_ENV_DATA"
      echo "The value of GLOBAL_VISIBLE_VAR is $GLOBAL_VISIBLE_VAR"
      echo "The value of MULTI_ENV_VAR is $MULTI_ENV_VAR"
      echo "Showing values of variables generated in previous jobs:"
      source "$MAVEN_PROJ_DIR/dynamicbuildvars.sh"
      env | grep DYNPASSVARS_
      echo "Showing dotenv variables"
      echo "MY_SECRET: $MY_SECRET"
      echo "MY_OTHER_SECRET: $MY_OTHER_SECRET"
      echo "Listing any *.env files to see if the secret is laying around in an artifact file..."
      ls *.env || true

# include a standardized plugin extension from a template repository
# which contains the template job: .freemarker-file-templating-plugin-extension
include:
  - project: 'guided-explorations/ci-cd-plugin-extensions/ci-cd-plugin-extension-freemarker-file-templating'
    file: '/ci-cd-plugin-extension-freemarker-file-templating.yml'

.config-file-build:
  #CUSTOM CI EXTENSION / PLUG-IN (WITH CODE ISOLATION)
  #This job demonstrates a leveraging a self-contain custom CI plugin extension
  extends: .ci-cd-plugin-extension-freemarker-file-templating
  stage: build_config_files
  
  #GitLab flow only builds when a target environment branch is merged - so no build on merge with master.
  # If you wanted to have "sandbox" be the development branch and build upon initial development, 
  # make it the default branch for the repo and delete "master"
  only:
    refs:
      - merge_requests
      - sandbox
      - stage
      - production
  
  #maps branch name to environment scope
  environment:
    name: $CI_COMMIT_REF_NAME
    
